--[[
	Project: NerfedUtils stack library
	Version: 1.0.0
	Authors: NerfedWar (http://www.nerfedwar.net - nerfed.war@gmail.com)
	         Others (see individual function comments)

GPL3 is applicable unless a different license is stated within a function comment block.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

]]

-- Stack
--
-- Basic usage:
-- s1 = NewStack()
-- s1:push(1, 2, 3)
-- x = s1:pop()
--
--  Author: akavel (http://snippets.luacode.org/?p=authors/akavel)
-- License: MIT/X11
function NewStack(t)
  local Stack = {
    push = function(self, ...)
      for _, v in ipairs{ ... } do
        self[#self + 1] = v
      end
    end,
    pop = function(self, num)
      local num = num or 1
      if num > #self then
        error("underflow in NewStack-created stack")
      end
      local ret = {}
      for i = num, 1, -1 do
        ret[#ret + 1] = table.remove(self)
      end
      return unpack(ret)
    end
  }
  return setmetatable(t or {}, { __index = Stack })
end